from math import gcd 
from math import inf 

def gcd_lst(lst):
    result = inf
    if len(lst) == 1:
        return lst[0]
    if len(lst) == 2:
        return gcd(lst[0], lst[1])
    for i in range(1, len(lst)): 
        current = gcd(lst[i], lst[0]) 
        if current < result: 
            result = current
    return result
    
def process_query(l, r, lst):
    values = []
    for i in range(l, r+1):
        for j in range(i, r+1):
            values.append(gcd_lst(lst[i:j+1]) * sum(lst[i:j+1]))
    return max(values)


inp = input().split(' ')
n = int(inp[0])
q = int(inp[1])

lst = [int(i) for i in input().split(' ')]

for i in range(q):
   l, r = (int(i)-1 for i in input().split(' '))
   print(process_query(l, r, lst))


