#include <bits/stdc++.h>
using namespace std;

#define DIMN 200007

struct quer {
    int l,r,ind;
};

int n, nq;
int a[DIMN];
int res[DIMN];
quer q[DIMN]; 

void solve(int l, int r, vector<quer> q) {
    if (l==r) {
        for (auto i : q)
            res[i.ind] = max(res[i.ind],a[l]*a[l]);
        return;
    }

    int m = (l+r)/2;
    vector<quer> lq,rq,v;
    for (auto i : q) {
        if (i.l <= m && i.r <= m) lq.push_back(i);
        else if (i.l > m && i.r > m) rq.push_back(i);
        else {
            //cout << i.l << " " << i.r << endl;
            int ll = i.l, rr = i.r;
            v.push_back(i); 
            i.r = m; lq.push_back(i); i.r = rr;
            i.l = m+1; rq.push_back(i); i.l = ll;
            //cout << i.l << " " << i.r << endl;
        }
    }

    vector<pair<int,int>> dp(n);
    dp[m] = {a[m],a[m]};
    dp[m+1] = {a[m+1],a[m+1]};
    //unordered_map<int,int> mpl; mpl[dp[m].second] = dp[m].first;
    //unordered_map<int,int> mpr; mpr[dp[m+1].second] = dp[m+1].first;
    vector<pair<int,pair<int,int>>> vl;
    vector<pair<int,pair<int,int>>> vr;
    for (int i = m-1; i >= l; i--) {
        dp[i] = {dp[i+1].first+a[i],__gcd(dp[i+1].second,a[i])};
        if (dp[i].second!=dp[i+1].second) {
            vl.push_back({i+1,dp[i+1]});
        }
    } 
    vl.push_back({l,dp[l]});
    for (int i = m+2; i <= r; i++) {
        dp[i] = {dp[i-1].first+a[i],__gcd(dp[i-1].second,a[i])};
        //mpr[dp[i].second] = max(dp[i].first,mpr[dp[i].second]);
        if (dp[i].second!=dp[i-1].second) {
            vr.push_back({i-1,dp[i-1]});
        }
    } 
    vr.push_back({r,dp[r]});

    for (auto k : v) {
        int lind = 0, rind = 0;
        int maxres = 0;//(dp[k.l].first+dp[k.r].first)*__gcd(dp[k.l].second,dp[k.r].second);
        for (auto i : vl) {
            int s1 = i.second.first;
            int g1 = i.second.second;
            if (i.first<k.l) {
                s1 = dp[k.l].first;
                g1 = dp[k.l].second;
            }
            for (auto j : vr) {
                int s2 = j.second.first;
                int g2 = j.second.second;
                if (j.first>k.r) {
                    s2 = dp[k.r].first;
                    g2 = dp[k.r].second;
                }
                maxres = max(maxres,(s1+s2)*__gcd(g1,g2));
            }
        }
        //cout << maxres << " " << k.ind << endl;
        res[k.ind] = max(res[k.ind],maxres);
    }

    //for (int i = l; i <= r; i++) cout << dp[i].first << " "; cout << endl;
    //for (int i = l; i <= r; i++) cout << dp[i].second << " "; cout << endl;
    //for (auto i : mpl) cout << i.first << "-"<<i.second << endl; cout << endl;
    //for (auto i : mpr) cout << i.first << "-"<<i.second << endl; cout << endl;
    //for (auto i : vl) cout << i.first << " " << i.second.first << " " << i.second.second << endl; cout << endl;
    //for (auto i : vr) cout << i.first << " " << i.second.first << " " << i.second.second << endl; cout << endl;
    solve(l,m,lq);
    solve(m+1,r,rq);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> nq;
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<quer> v;
    for (int i = 0; i < nq; i++) {
        cin >> q[i].l >> q[i].r; q[i].l--; q[i].r--;
        q[i].ind = i;
        v.push_back(q[i]);
    }
    solve(0,n-1,v);
    for (int i = 0; i < nq; i++) {
        cout << res[i] << endl;
    }
}
