#include <bits/stdc++.h>

using namespace std;

int n, q, l, r, L, R;
long long res, res1;
int a[200007];
long long presum[200007];
int T[4*200007];

int gcd(int a, int b){
    int ans = max(a, b);
    for (int i = 1; i <= min(a, b); i++){
        if (a%i == 0 && b%i == 0) ans = i;
    }
    if (a == b) return a;
    return ans;
}

void BuildTree(int v, int tl, int tr){
    if (tl == tr){ T[v] = a[tl]; return; }
    int tm = (tl+tr)/2;
    BuildTree(2*v+1, tl, tm);
    BuildTree(2*v+2, tm+1, tr);
    T[v] = gcd(T[2*v+1], T[2*v+2]);
}

int GetGCD(int v, int tl, int tr, int L, int R){
    if (L > tr || R < tl) return 0;
    if (L <= tl && R >= tr) return T[v];
    int tm, gcd1, gcd2;
    tm = (tl+tr)/2;
    gcd1 = GetGCD(2*v+1, tl, tm, L, R);
    gcd2 = GetGCD(2*v+2, tm+1, tr, L, R);
    return gcd(gcd1, gcd2);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> q;
    presum[0] = 0;
    for (int i = 0; i < n; i++){
        cin >> a[i];
        presum[i+1] = presum[i] + a[i];
    }
    BuildTree(0, 0, n-1);
    for (int i = 0; i < q; i++){
        cin >> L >> R;
        res = 0;
        for (l = L; l <= R; l++)
            for (r = l; r <= R; r++){
                res1 = presum[r] - presum[l-1];
                res1 *= GetGCD(0, 0, n-1, l-1, r-1);
                res = max(res, res1);
            }
        cout << res << '\n';
    }
    cout << endl;
    return 0;
}
