#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define x first
#define y second
#define pb push_back
#define all(x) x.begin(),x.end()
#define sz(x) x.size()
#define SH(x) cout<<(#x)<<" = "<<x<<'\n';

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

int n, m;

bool valid(int i, int j) {
    if (i < 0 || j < 0 || i >= n || j >= m) return 0;
    return 1;
}

void solve() {
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    vector<vector<int>> mx(n, vi(m, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    for (int x = 0; x < n; ++x) {
        for (int y = 0; y < m; ++y) {
            if (a[x][y] != 'H') continue;
            queue<pii> q;
            vector<vector<int>> dist(n, vi(m, -1));
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    dist[i][j] = -1;
                }
            }
            q.push({x, y});
            dist[x][y] = 0;
            while (!q.empty()) {
                auto [i, j] = q.front();
                q.pop();
                if (valid(i - 1, j) && a[i - 1][j] != 'F' && dist[i - 1][j] == -1) {
                    dist[i - 1][j] = dist[i][j] + 1;
                    q.push({i - 1, j});
                }
                if (valid(i + 1, j) && a[i + 1][j] != 'F' && dist[i + 1][j] == -1) {
                    dist[i + 1][j] = dist[i][j] + 1;
                    q.push({i + 1, j});
                }
                if (valid(i, j - 1) && a[i][j - 1] != 'F' && dist[i][j - 1] == -1) {
                    dist[i][j - 1] = dist[i][j] + 1;
                    q.push({i, j - 1});
                }
                if (valid(i, j + 1) && a[i][j + 1] != 'F' && dist[i][j + 1] == -1) {
                    dist[i][j + 1] = dist[i][j] + 1;
                    q.push({i, j + 1});
                }
            }
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    if (a[i][j] != 'H' && a[i][j] != 'F') {
                        mx[i][j] = max(mx[i][j], dist[i][j]);
                    }
                }
            }
        }
    }
    int mn = 1e18 + 5;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] != 'H' && a[i][j] != 'F') {
                mn = min(mn, mx[i][j]);
            }
        }
    }
    vector<pii> ans;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] != 'H' && a[i][j] != 'F' && mx[i][j] == mn) {
                ans.emplace_back(i, j);
            }
        }
    }
    cout << sz(ans) << '\n';
    for (auto [i, j] : ans) cout << i + 1 << ' ' << j + 1 << '\n';
}

signed main() {
    cin.tie(NULL)->ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    while (t--) solve();
}
