#include <bits/stdc++.h>
#define int long long
using namespace std;

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n,m;
    cin>>n>>m;
    char mas[n][m];
    int dist[n][m];
    vector <pair <int,int> > holes;
    for (int i=0; i<n; i++){
        for (int j=0; j<m; j++){
            cin>>mas[i][j];
            dist[i][j]=0;
            if (mas[i][j]=='H') holes.push_back({i,j});
        }
    }
    for (int k=0; k<holes.size(); k++){
        int used[n][m];
        int dist2[n][m];
        for (int i=0; i<n; i++){
            for (int j=0; j<m; j++){
                dist2[i][j]=0;
                used[i][j]=0;
            }
        }
        queue <pair <int, int> > q;
        q.push({holes[k].first, holes[k].second});
        used[holes[k].first][holes[k].second]=1;
        while (!q.empty()){
            int x=q.front().first, y=q.front().second;
            if (x+1<n && mas[x+1][y]!='F' && used[x+1][y]==0){
                q.push({x+1,y});
                used[x+1][y]=1;
                dist2[x+1][y]=dist2[x][y]+1;
            }
            if (y+1<m && mas[x][y+1]!='F' && used[x][y+1]==0){
                q.push({x,y+1});
                used[x][y+1]=1;
                dist2[x][y+1]=dist2[x][y]+1;
            }
            if (x-1>=0 && mas[x-1][y]!='F' && used[x-1][y]==0){
                q.push({x-1,y});
                used[x-1][y]=1;
                dist2[x-1][y]=dist2[x][y]+1;
            }
            if (y-1>=0 && mas[x][y-1]!='F' && used[x][y-1]==0){
                q.push({x,y-1});
                used[x][y-1]=1;
                dist2[x][y-1]=dist2[x][y]+1;
            }
            q.pop();
        }
        for (int i=0; i<n; i++){
            for (int j=0; j<m; j++){
                if (dist2[i][j]>dist[i][j]) dist[i][j]=dist2[i][j];
            }
        }
    }
    vector <pair <int,int> > ans;
    int maxi=1e10;
    for (int i=0; i<n; i++){
        for (int j=0; j<m; j++){
            if (mas[i][j]!='F' && dist[i][j]<maxi){
                ans.clear();
                maxi=dist[i][j];
                ans.push_back({i+1,j+1});
            }
            else if (mas[i][j]!='F' && dist[i][j]==maxi){
                ans.push_back({i+1,j+1});
            }
        }
    }
    cout<<ans.size()<<'\n';
    for (int i=0; i<ans.size(); i++){
        cout<<ans[i].first<<" "<<ans[i].second<<'\n';
    }
    return 0;
}
