#include <bits/stdc++.h>
#define int long long
using namespace std;
int n;
int mas[1000000]= {0};
int sum[1000000]= {0};
int gcdtree[1000000]= {0};
int gcd(int a, int b)
{
    if (a<b) swap(a,b);
    if (b==0) return a;
    else return gcd(b,a%b);
}
void build(int l, int r, int v)
{
    if (l==r)
    {
        sum[v]=mas[l];
        gcdtree[v]=mas[l];
    }
    else if (l<r)
    {
        build(l,(l+r)/2,v*2);
        build((l+r)/2+1,r,v*2+1);
        sum[v]=sum[v*2]+sum[v*2+1];
        gcdtree[v]=gcd(gcdtree[v*2],gcdtree[v*2+1]);
    }
}
int getsum(int l, int r, int l1, int r1, int v)
{
    if (l1==l && r1==r) return sum[v];
    else if (l1==r1) return mas[l1];
    else
    {
        int x=(r+l)/2;
        if (l1>x) return getsum(x+1,r,l1,r1,v*2+1);
        else if (r1<=x) return getsum(l,x,l1,r1,v*2);
        else return getsum(l,x,l1,x,v*2)+getsum(x+1,r,x+1,r1,v*2+1);
    }
}
int getgcd(int l, int r, int l1, int r1, int v)
{
    if (l1==l && r1==r) return gcdtree[v];
    else if (l1==r1) return mas[l1];
    else
    {
        int x=(r+l)/2;
        if (l1>x) return getgcd(x+1,r,l1,r1,v*2+1);
        else if (r1<=x) return getgcd(l,x,l1,r1,v*2);
        else return gcd(getgcd(l,x,l1,x,v*2),getgcd(x+1,r,x+1,r1,v*2+1));
    }
}
signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin>>n>>q;
    for (int i=1; i<=n; i++) cin>>mas[i];
    build(1,n,1);
    int res[n+5][n+5];
    for (int i=1; i<=n; i++){
        for (int j=i; j<=n; j++) res[i][j]=getsum(1,n,i,j,1)*getgcd(1,n,i,j,1);
    }
    while (q--)
    {
        int l,r;
        cin>>l>>r;
        int maxi=1;
        for (int i=l; i<=r; i++){
            for (int j=i; j<=r; j++) maxi=max(maxi,res[i][j]);
        }
        cout<<maxi<<'\n';
    }
    return 0;
}
