n, m = map(int, input().split())
field = []
for _ in range(n):
    field.append(list(input()))


def find_holes():
    res = []

    for row in range(n):
        for col in range(m):
            if field[row][col] == "H":
                res.append((row, col, 0))

    return res


q = find_holes()
checked = []
nf = [[0] * m for _ in range(n)]
num_fields = [[[0] * m for _ in range(n)] for _ in range(len(q))]

for i in range(len(num_fields)):
    cur_hole = [q[i]]
    while len(cur_hole) != 0:
        cur_cell = cur_hole.pop()
        x = cur_cell[1]
        y = cur_cell[0]
        dist = cur_cell[2]
        num_fields[i][y][x] = dist
        checked.append((x, y))

        directs = [(1, 0), (-1, 0), (0, 1), (0, -1)]
        for x_d, y_d in directs:
            if 0 <= x_d + x < m-1 and 0 <= y_d + y < n and (x_d + x, y + y_d) not in checked:
                if field[y + y_d][x + x_d] in ('.', 'H'):
                    cur_hole.insert(0, (y + y_d, x + x_d, dist+1))
    checked = []

# for nf in num_fields:
#     for row in nf:
#         print(row)
# 
#     print()
# print()
# for row in field:
#     print(row)
# 
# 
res_field = [[0] * m for _ in range(n)]
for y in range(n):
    for x in range(m):
        for i in range(len(num_fields)):
            res_field[y][x] += num_fields[i][y][x]
# 
# for row in res_field:
#     print(row)

min_d = m*n
for row in res_field:
    for num in row:
        if num == 0:
            continue
        min_d = min_d if min_d < num else num


indx = []

for y in range(len(res_field)):
    for x in range(len(res_field[0])):
        if res_field[y][x] == min_d and field[y][x] != "H":
            indx.append((x, y))

print(len(indx))
for c in indx:
    print(c[0]+1, c[1]+1)
