// M24D.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <set>
#include <vector>
#include <climits>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;
typedef long long ull;
typedef pair<int, int> pint;
typedef pair<ll, ll> pll;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, m;
    cin >> n >> m;
    char* ar = new char[n*m];
    int* sar = new int[n * m];
    int* bar = new int[n * m];
    for (int i = 0; i < n * m; i++) bar[i] = sar[i] = 0;
    vector<pint> crp;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            char c; cin >> c;
            ar[i*m+j] = c;
            if (c == 'H') crp.push_back(pint(i, j));
        }
    }
    for (int i = 0; i < crp.size(); i++)
    {
        vector<pint> npos = { crp[i] };
        bar[crp[i].first*m+crp[i].second] = (10 + i * 10);
        int stepcnt = 0;
        while (npos.size() != 0)
        {
            vector<pint> nextpos;
            for (int j = 0; j < npos.size(); j++)
            {
                sar[npos[j].first*m+npos[j].second] = max(stepcnt, sar[npos[j].first*m+npos[j].second]);
                if (npos[j].first != 0 && ar[(npos[j].first - 1)*m+npos[j].second] != 'F' && bar[(npos[j].first - 1)*m+npos[j].second]!= (10 + i * 10))
                {
                    bar[(npos[j].first - 1)*m+npos[j].second] = 10+i*10;
                    nextpos.push_back(pint(npos[j].first - 1, npos[j].second));
                }
                if (npos[j].second != 0 && ar[npos[j].first*m+npos[j].second - 1] != 'F' && bar[npos[j].first*m+npos[j].second - 1] != (10 + i * 10))
                {
                    bar[npos[j].first*m+npos[j].second - 1] = 10 + i * 10;
                    nextpos.push_back(pint(npos[j].first, npos[j].second - 1));
                }
                if (npos[j].first != (n-1) && ar[(npos[j].first + 1)*m+npos[j].second] != 'F' && bar[(npos[j].first + 1)*m+npos[j].second] != (10 + i * 10))
                {
                    bar[(npos[j].first + 1)*m+npos[j].second] = 10 + i * 10;
                    nextpos.push_back(pint(npos[j].first + 1, npos[j].second));
                }
                if (npos[j].second != (m-1) && ar[npos[j].first*m+npos[j].second + 1] != 'F' && bar[npos[j].first*m+npos[j].second + 1] != (10 + i * 10))
                {
                    bar[npos[j].first*m+npos[j].second + 1] = 10 + i * 10;
                    nextpos.push_back(pint(npos[j].first, npos[j].second + 1));
                }
            }
            stepcnt++;
            npos = nextpos;
        }
    }
    int msar = INT_MAX;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (ar[i*m+j] != 'F') msar = min(msar, sar[i*m+j]);
        }
    }
    vector<pint> res;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (sar[i*m+j] == msar && ar[i*m+j] != 'F') res.push_back(pint(i, j));
        }
    }
    cout << res.size() << "\n";
    for (int i = 0; i < res.size(); i++)
    {
        cout << res[i].first + 1 << " " << res[i].second + 1 << "\n";
    }
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
