#include <iostream>
#include <map>
#include <vector>

using namespace std;

int main() {
    int length, ops;
    cin >> length >> ops;
    ops += 1;

    map<int, int> permutation_map{};

    for (int i = 0; i < length; i++) {
        int element;
        cin >> element;

        permutation_map[element] = i + 1;
    }

    map<int, pair<int, int>> element_loops{};
    map<int, vector<long long>*> loops{};
    int loop_id = -1;

    for (int i = 1; i <= length; i++) {
        if (permutation_map[i] == i || element_loops.find(i) != element_loops.end()) {
            continue;
        }

        loop_id += 1;

        int current = permutation_map[i];

        loops[loop_id] = new vector<long long> { i };
        element_loops[i] = { loop_id, 0 };

        int index = 1;

        while (current != i) {
            loops[loop_id]->push_back(current + loops[loop_id]->back());
            element_loops[current] = { loop_id, index };
            current = permutation_map[current];

            index += 1;
        }
    }

    // for (int i = 0; i < 2; i++) {
    //     cout << i << ": ";

    //     for (int sum : loops[i]) {
    //         cout << sum << " ";
    //     }

    //     cout << "\n";
    // }

    // for (int i = 1; i <= length; i++) {
    //     auto [loop_id, loop_index] = element_loops[i];
    //     vector<long long>* loop = loops[loop_id];

    //     int full_loops = ops / loop->size();
    //     int extra = ops % loop->size();

    //     long long result = full_loops * loop->back() - i;

    //     if (extra > 0) {
    //         int start_index = loop_index - 1;
    //         int end_index = min((int)loop->size() - 1, loop_index + extra - 1);
    //         int overlap_end_index = loop_index + extra - loop->size() - 1;

    //         result += (*loop)[end_index] + (overlap_end_index >= 0 ? (*loop)[overlap_end_index] : 0) - (start_index >= 0 ? (*loop)[start_index] : 0);
    //         // cout << i << " " << (*loop)[end_index] << " " << (overlap_end_index >= 0 ? (*loop)[overlap_end_index] : 0) << " " << (start_index >= 0 ? (*loop)[start_index] : 0) << "\n";
    //     }

    //     // cout << result << " ";
    // }

    // cout << "\n";

    return 0;
}
