#pragma GCC optimize("O3", "Ofast", "unroll-loops")
#include <bits/stdc++.h>
using namespace std;
typedef unsigned long long ll;

ll calc(vector<vector<ll>>& dp, vector<vector<ll>>& gdp, vector<ll>& a, vector<ll>& b, ll i, ll j, ll l, ll r) {
    if (i < l || j > r) return 0;
    if (i == j) return dp[i][j] = a[i] * a[i];
    if (dp[i][j] != -1) return dp[i][j];
    dp[i + 1][j] = calc(dp, gdp, a, b, i + 1, j, l, r);
    dp[i][j - 1] = calc(dp, gdp, a, b, i, j - 1, l, r);
    dp[i][j] = max((b[j] - b[i] + a[i]) * gdp[i][j], max(dp[i + 1][j], dp[i][j - 1]));
    return dp[i][j];
}

void solve() {
    ll n, q; cin >> n >> q;
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) cin >> a[i];
    ll l, r;
    vector<vector<ll>> gdp(n, vector<ll>(n));
    vector<vector<ll>> dp(n, vector<ll>(n, -1));
    for (ll i = 0; i < n; i++) {
        ll g = a[i];
        for (ll j = i; j < n; j++) {
            g = gcd(g, a[j]);
            gdp[i][j] = g;
        }
    }
    vector<ll> b(n, a[0]);
    for (ll i = 1; i < n; i++) {
        b[i] = b[i - 1] + a[i];
    }
    for (ll ttt = 0; ttt < q; ttt++) {
        cin >> l >> r;
        l--; r--;
        ll ans = calc(dp,gdp,a,b,l,r,l,r);
        cout << ans << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}
