#pragma GCC optimize("O3", "Ofast", "unroll-loops")
#include <bits/stdc++.h>
using namespace std;
typedef unsigned long long ll;

ll calc(vector<vector<ll>>& dp, ll g, vector<ll>& a, vector<ll>& b, ll i, ll j, ll l, ll r) {
    if (i < l || j > r) return 0;
    if (dp[i-l][r-j] != -1) return dp[i - l][r-j];
    ll an = 0, bn = 0;
    if (i != l) an = calc(dp, gcd(g, a[i - 1]), a, b, i - 1, j, l, r);
    if (j != r) bn = calc(dp, gcd(g, a[j + 1]), a, b, i, j + 1, l, r);
    dp[i - l][r-j] = max((b[j] - b[i] + a[i]) * g, max(an, bn));
    return dp[i - l][r-j];
}

void solve() {
    ll n, q; cin >> n >> q;
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) cin >> a[i];
    ll l, r;
    vector<ll> b(n, a[0]);
    for (ll i = 1; i < n; i++) {
        b[i] = b[i - 1] + a[i];
    }
    for (ll ttt = 0; ttt < q; ttt++) {
        cin >> l >> r;
        l--; r--;
        ll ans = 0;
        for (ll i = l; i <= r; i++) {
            vector<vector<ll>> dp(r-l+1, vector<ll>(r-l+1, -1));
            ans = max(ans, calc(dp, a[i], a, b, i, i, l, r));
        }
        cout << ans << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}
