#include<bits/stdc++.h>

#define endl '\n'

using namespace std;

const int dim = 1e3+7, dim1 = 107;

struct res{
    int dist, x, y;
};

typedef pair<int, int> pii;
int n, m, holes = 0;
vector<vector<char>> a;
vector<vector<int>> used[dim1];
queue<pii> q;
vector<pii> hole;
vector<res> d;

bool cmp(res x, res y){
    return x.dist<y.dist;
}

void check(int x, int y, int num, int dist){
    if(x<1 || y<1 || x>n || y>m || a[x-1][y-1]=='F' || used[num][x-1][y-1]!=0)return;

    used[num][x-1][y-1] = dist+1;
    q.push({x, y});
}

void solve(int x, int y, int num){
    while(!q.empty())q.pop();

    q.push({x, y});
    used[num][x-1][y-1] = 1;

    while(!q.empty()){
        pii v = q.front();
        q.pop();

        int xv = v.first, yv = v.second;
        int dist = used[num][xv-1][yv-1];

        check(xv+1, yv, num, dist);
        check(xv, yv+1, num, dist);
        check(xv-1, yv, num, dist);
        check(xv, yv-1, num, dist);
    }
}

int main(){

    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m;
    a.resize(n+7);
    for(int i = 1; i<=n; i++){
        a[i-1].resize(m+7);
    }
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
            cin >> a[i-1][j-1];
            if(a[i-1][j-1]=='H'){
                holes++;
                hole.push_back({i, j});
            }
        }
    }

    for(int i = 1; i<=holes; i++){
        used[i].resize(n+7);
        for(int j = 1; j<=n; j++){
            used[i][j-1].resize(m+7);
        }
    }

    for(int i = 0; i<holes; i++){
        solve(hole[i].first, hole[i].second, i+1);

//        cout << endl;
//        for(int k = 1; k<=n; k++){
//            for(int j = 1; j<=m; j++){
//                cout << used[k][j][i+1] << " ";
//            }
//            cout << endl;
//        }
    }

    int mi;
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
            if(a[i-1][j-1]!='F'){
                mi = 0;
                for(int h = 1; h<=holes; h++){
                    mi = max(mi, used[h][i-1][j-1]);
                }
                d.push_back({mi, i, j});
            }
        }
    }

    sort(d.begin(), d.end(), cmp);
    int cnt = 0, last = 0;

//    cout << endl;
//    for(auto b : d){
//        cout << b.dist << " ";
//    }
//    cout << endl;

    for(int i = 0; i<d.size(); i++){
        if(d[i].dist!=d[last].dist){
            cnt = i;
            break;
        }
        last = i;
    }
    if(cnt==0)cnt = d.size();

    cout << cnt << endl;
    for(int i = 0; i<cnt; i++){
        cout << d[i].x << " " << d[i].y << endl;
    }

    return 0;
}
