#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int n, m;
    cin >> n >> m;

    string a[n];

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    int mx[n][m] = {};
    int can[n][m] = {};

    int num = 0;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == 'H') {
                bool seen[n][m] = {};
                int dist[n][m] = {};
                num++;
                queue<pair<int, int>> q;
                q.push({i, j});

                while (!q.empty()) {
                    auto top = q.front();
                    q.pop();
                    can[top.first][top.second]++;
                    mx[top.first][top.second] = max(mx[top.first][top.second], dist[top.first][top.second]);

                    for (int delx : {-1, 0, 1}) {
                        for (int dely : {-1, 0, 1}) {
                            if ((delx == 0) == (dely == 0)) continue;

                            if (top.first + delx >= 0 && top.first + delx < n && top.second + dely >= 0 
                                && top.second + dely < m && !seen[top.first + delx][top.second + dely] &&
                                 a[top.first + delx][top.second + dely] != 'F') {
                                q.push({top.first + delx, top.second + dely});
                                dist[top.first + delx][top.second + dely] = dist[top.first][top.second] + 1;
                                seen[top.first + delx][top.second + dely] = true;
                            }
                        }
                    }
                }
            }
        }
    }

    int mn = INT_MAX;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (can[i][j] == num) {
                mn = min(mn, mx[i][j]);
            }
        }
    }

    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (can[i][j] == num && mx[i][j] == mn) {
                ans.push_back({i + 1, j + 1});
            }
        }
    }

    printf("%i\n", ans.size());
    for (auto an : ans) {
        printf("%i %i\n", an.first, an.second);
    }

}
