#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int n, q;
    cin >> n >> q;

    ll a[n + 1];
    for (int i = 0; i < n; i++) {
        cin >> a[i + 1];
    }

    ll ans[n + 1][n + 1] = {};

    for (int i = 1; i <= n; i++) {
        ll sum = 0;
        ll g = a[i];
        for (int j = i; j <= n; j++) {
            sum += a[j];
            g = __gcd(g, a[j]);

            ans[i][j] = sum * g;
        }
    }

    ll lg = log2(n) + 2;

    ll sp[n + 1][n + 1][lg];
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            sp[i][j][0] = ans[i][j];
        }
    }

    for (int k = 1; k <= lg; k++) {
        for (int i = 1; i <= n - (1 << k) + 1; i++) {
            for (int j = 1; j <= n - (1 << k) + 1; j++) {
                sp[i][j][k] = max({sp[i][j][k - 1], sp[i + (1 << (k - 1))][j][k - 1],
                    sp[i][j + (1 << (k - 1))][k - 1], sp[i + (1 << k - 1)][j + (1 << (k - 1))][k - 1]});
            }
        }
    }

    while (q--) {
        ll l, r;
        cin >> l >> r;

        ll lg = floor(log2(r - l + 1));

        ll ans = max({sp[l][l][lg], sp[r - (1 << lg) + 1][l][lg], sp[l][r - (1 << lg) + 1][lg],
         sp[r - (1 << lg) + 1][r - (1 << lg) + 1][lg]});

         printf("%lld\n", ans);
    }

}
