#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <iomanip>
#include <string>
#include <map>
#include <numeric>
#include <set>
#include <unordered_map>

using namespace std;

typedef long long lli;
#define LF '\n';

vector<vector<int>> arr;
vector<vector<int>> arr2;
vector<vector<int>> arr3;
vector<pair<lli, lli>> res;
vector<pair<lli, lli>> h;

void dfs(lli x, lli y, lli d)
{
    if (arr[x][y] == -1)return;
    if (d >= arr2[x][y])return;
    arr2[x][y] = d;
    dfs(x + 1, y, d + 1);
    dfs(x - 1, y, d + 1);
    dfs(x, y+1, d + 1);
    dfs(x, y-1, d + 1);
}

void solve()
{
    lli n, m;
    cin >> n >> m;
    arr.resize(n + 2);
    arr2.resize(n + 2);
    arr3.resize(n + 2);
    for (int i = 0; i <= n + 1; i++)arr[i].resize(m + 2, -1);
    for (int i = 0; i <= n + 1; i++)arr2[i].resize(m + 2, 100000000);
    for (int i = 0; i <= n + 1; i++)arr3[i].resize(m + 2,0);
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            char c;
            cin >> c;
            if (c == '.')arr[i][j] = 0;
            if (c == 'H') {
                arr[i][j] = 1;
                h.push_back({ i,j });
            }
        }
    }

    for (auto to : h) {
        dfs(to.first, to.second, 0);
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= m; j++) {
                arr3[i][j] = max(arr3[i][j], arr2[i][j]);
                arr2[i][j] = 100000000;
            }
        }
    }
    lli minn = 1e9;
    for (int i = 1; i <= n; i++)for (int j = 1; j <= m; j++)minn = min(minn, (lli)arr3[i][j]);
    for (int i = 1; i <= n; i++)for (int j = 1; j <= m; j++)if (arr3[i][j] == minn)res.push_back({ i,j });
    cout << res.size() << LF;
    for (auto to : res)cout << to.first << " " << to.second << LF;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
 //   freopen("input.txt", "r", stdin);
   // freopen("output.txt", "w", stdout);

    solve();
}

