#include <iostream>
#include <cmath>
using namespace std;

void in_array(int ar[], int ar_sum[], int N)
{
    int sum = 0;
    for (int i = 0; i < N; ++i)
    {
        cin >> ar[i];
        sum += ar[i];
        ar_sum[i] = sum;
    }
}

int GCD(int a, int b)
{
    while (a != 0 && b != 0)
    {
        a %= b;
        if (a != 0)
            b %= a;
    }
    return a + b;
}

int get_GCD(int ar[], int l, int r)
{
    int gcd = ar[l];
    for (int i = l; i <= r; ++i)
    {
        gcd = GCD(gcd, ar[i]);
    }
    return gcd;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int ar[200000] = {0}, ar_sum[200000], N, qty, left, right, sum = 0, gcd, mult;

    cin >> N >> qty;
    in_array(ar, ar_sum, N);

    while (qty != 0)
    {
        cin >> left >> right;
        left--;
        right--;
        sum = abs(ar_sum[right] - ar_sum[left]) + ar[left];
        //if (sum == 0)
          //  sum = ar_sum[left];
        gcd = get_GCD(ar, left, right);
        mult = sum * gcd;
        cout << mult << '\n';
        qty--;
    }

}
