#include <bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2,tune=native")
using namespace std;
using ll = long long;

constexpr ll INF = 1000000000000LL;
constexpr ll sq = 450;

ll n, m, q, k, x, y, a, b, c;
vector<ll> v;
vector<ll> pr;
vector< vector<ll> > divs;

ll inter(pair<ll, ll> a, pair<ll, ll> b) {
    if (a.first > b.first) {
        swap(a, b);
    }
    if (b.first > a.second) {
        return 0;
    }
    return pr[min(b.second, a.second) + 1] - pr[max(a.first, b.first)];
}

struct segtree {
    vector<ll> tr;

    void build(ll x, ll l, ll r, vector<ll> &v) {
        if (l == r) {
            tr[x] = v[l];
            return;
        }
        ll mid = (r + l) / 2;
        build(x * 2 + 1, l, mid, v);
        build(x * 2 + 2, mid + 1, r, v);
        tr[x] = max(tr[x * 2 + 1], tr[x * 2 + 2]);
    }

    segtree() {

    }

    segtree(vector<ll> &v) {
        tr.resize(4 * v.size());
        build(0, 0, v.size() - 1, v);
    }

    ll get(ll x, ll l, ll r, ll L, ll R) {
        if (l > r) {
            return -INF;
        }
        if (L > r) {
            return -INF;
        }
        if (l > R) {
            return -INF;
        }
        if (L <= l && r <= R) {
            return tr[x];
        }
        ll mid = (l + r) / 2;
        return max(get(x * 2 + 1, l, mid, L, R), get(x * 2 + 2, mid + 1, r, L, R));
    }
};

unordered_map< ll, vector< pair<ll, ll> > > vr;
unordered_map<ll, segtree> sg;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(NULL));
    
    cin >> n >> q;
    v.resize(n);
    set<ll> st;
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        // v[i] = (rand() % 6000000) + 1;
    }
    // cout << st.size() << endl;
    pr.resize(n + 1);
    for (int i = 0; i < n; i++) {
        pr[i + 1] = pr[i] + v[i];
    }
    vector<ll> ans(q);
    vector< pair< pair<ll, ll>, ll> > vp;
    for (int i = 0; i < q; i++) {
        cin >> x >> y;
        // x = 1;
        // y = (rand() % n) + 1;
        x--;
        y--;
        vp.push_back({{x, y}, i});
    }
    sort(vp.begin(), vp.end());
    map<ll, ll> mp;
    mp[v[0]] = v[0];
    ll pos = 0;
    ll mx = v[0] * v[0];
    while (pos < q && vp[pos].first.second == 0) {
        ans[vp[pos].second] = mx;
        pos++;
    }
    for (int i = 1; i < n; i++) {
        map<ll, ll> mp1;
        for (auto j : mp) {
            mp1[gcd(j.first, v[i])] = max(mp1[gcd(j.first, v[i])], j.second + v[i]);
            mx = max(mx, mp1[gcd(j.first, v[i])] * gcd(j.first, v[i]));
        }
        mp1[v[i]] = max(mp1[v[i]], v[i]);
        mx = max(mx, v[i] * v[i]);
        swap(mp, mp1);
        while (pos < q && vp[pos].first.second == i) {
            ans[vp[pos].second] = mx;
            pos++;
        }
    }
    for (int j = 0; j < q; j++) {
        cout << ans[j] << '\n';
    }
}
