#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pldld;
const ll INF = 2e3+5, LONGBOI = 1e14+5;
mt19937 REALrandom(chrono::system_clock::to_time_t(chrono::system_clock::now()));

//struct mycomp{
//    bool operator()(str &a, str &b) const{
//    }
//};
//
//bool operator < (str &a, str &b){
//}

ll n, q, l, r;
ll a[INF];
ll pref[INF], tg[4*INF];

ll f[INF][INF];

//// START BUILD

void build1(){
    for(int i=1; i <= n; i++){
        pref[i] = a[i] + pref[i-1];
    }
    return;
}

void build2(ll we, ll l, ll r){
    if(l == r){
        tg[we] = a[l];
        //cout << "we = " << we << " tg = " << tg[we] << endl;
        return;
    }

    ll m = (l+r)>>1;
    build2(2*we+1, l, m);
    build2(2*we+2, m+1, r);

    tg[we] = __gcd(tg[2*we+1], tg[2*we+2]);
    //cout << "we = " << we << " tg = " << tg[we] << endl;
    return;
}

//// END BUILD

// GET START

ll Get1(ll l, ll r){
    if(l == 1) return pref[r];
    else return (pref[r] - pref[l-1]);
}

ll Get2(ll we, ll l, ll r, ll tl, ll tr){
    if(l > tr || r < tl) return 0;

    //cout << "we = " << we << " tg = " << tg[we] << endl;

    if(tl <= l && r <= tr) return tg[we];

    ll m = (l+r)>>1;
    return __gcd(Get2(2*we+1, l, m, tl, tr), Get2(2*we+2, m+1, r, tl, tr));
}

//// GET END

void start(ll l, ll r, ll we, ll &sum, ll &gcd){

    sum += a[we];
    ll last = gcd;
    gcd = __gcd(gcd, a[we]);
    f[l][r] = sum * gcd;
    f[l][r] = max(f[l][r], max(f[l+1][r], f[l][r-1]));

    if(l > 0){
        start(l-1, r, l-1, sum, gcd);
    }
    if(r < n){
        start(l, r+1, r+1, sum, gcd);
    }

    sum -= a[we];
    gcd = last;
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> q;
    for(int i=1; i <= n; i++) cin >> a[i];
//
//    build1();
//    build2(0, 1, n);

    ll sum=0, gcd=0;
    for(int i=1; i <= n; i++){
        start(i, i, i, sum, gcd);
    }

    ll ans;
    for(int i=1; i <= q; i++){
        cin >> l >> r;
        //cout << "sum = " << Get1(0, 1, n, l, r) << endl;
        //cout << "gcd = " << Get2(0, 1, n, l, r) << endl;
        ans = 0;
        for(int j=l; j <= r; j++){
            for(int p=j; p <= r; p++){
                ans = max(ans, Get1(j, p) * Get2(0, 1, n, j, p));
            }
        }
        cout << f[l][r] << endl;
    }

    return 0;
}
