#include <algorithm>
#include <cmath>
#include <iostream>
#include <map>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define lf long double
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define nl "\n"

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  ll n, m, k;
  ll a, b, c, d, e, f, x, y, p, o, q;
  string str;
  char ch;
  cin >> n >> k;
  vector<ll> permutation(n + 1);
  map<ll, ll> mp;
  vector<ll> positions(n + 1);
  vector<ll> answer(n + 1);
  for (ll i = 1; i <= n; i++) {
    cin >> permutation[i];
    mp[permutation[i]] = i;
    answer[i] = 0;
    positions[i] = i;
  }
  while (k--) {
    for (ll i = 1; i <= n; i++) {
      positions[i] = mp[positions[i]];
      answer[i] += positions[i];
    }
  }
  for (ll i = 1; i <= n; i++) {
    cout << answer[i] << " ";
  }
}
