#include <bits/stdc++.h>
using namespace std;

#define DIMN 200007

int n, m;
vector<vector<int>> a;
vector<vector<int>> d;
vector<vector<int>> u;
vector<int> buf;
/*
if (x < 0 || y < 0 || x >= n || y >= m) return;
    if (u[x][y]==k||a[x][y]==-1) return;
    u[x][y]=k;
    d[x][y] = max(d[x][y],dist);
    calcdist(x-1,y,dist+1,k);
    calcdist(x+1,y,dist+1,k);
    calcdist(x,y-1,dist+1,k);
    calcdist(x,y+1,dist+1,k);
*/
void calcdist(int x, int y, int dist, int k) {
    priority_queue<pair<int,pair<int,int>>,vector<pair<int,pair<int,int>>>, greater<pair<int,pair<int,int>>>> pq;
    pq.push({0,{x,y}});
    while(!pq.empty()) {
        int dst = pq.top().first;
        int x = pq.top().second.first;
        int y = pq.top().second.second;
        pq.pop();
        if (x<0||y<0||x>=n||y>=m) continue;
        if (u[x][y] == k||a[x][y]==-1) continue;
        u[x][y] = k;
        d[x][y] = max(d[x][y],dst);
        pq.push({dst+1,{x+1,y}});
        pq.push({dst+1,{x-1,y}});
        pq.push({dst+1,{x,y+1}});
        pq.push({dst+1,{x,y-1}});
    }
}

void cot() {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << d[i][j] << " ";
        }
        cout << endl;
    }cout << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    char c;
    buf.assign(m,0);
    a.assign(n,buf);
    d.assign(n,buf);
    u.assign(n,buf);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> c;
            if (c=='F') a[i][j] = -1;
            else if (c=='H') a[i][j] = 1;
        }
    }
    int k = 1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == 1) {
                calcdist(i,j,0,k);
                k++;
                //cot();
            }
        }
    }
    int mn = 1e9;
    vector<pair<int,int>> v;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j]!=-1&&d[i][j] < mn) {
                mn = d[i][j];
                v.clear();
                v.push_back({i,j});
            }
            else if (d[i][j]==mn) v.push_back({i,j});
            //cout << d[i][j] << " ";
        }
        //cout << endl;
    }
    cout << v.size() << endl;
    for (auto i : v) cout << i.first+1 << " " << i.second+1 << endl;
}
