#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const int msz = 2e5 + 5;

struct qr{
    int l, r, i;
};

vector<int> a(msz);
vector<ll> out(msz);

bool cmp(qr x, qr y){
    if (x.l == y.l){
        return x.r < y.r;
    }
    return x.l > y.l;
}

void solve(int l, int r, vector<qr> qs){
    if (qs.empty()) return;
    if (l == r){
        out[qs[0].i] = a[qs[0].l] * a[qs[0].r];
        return;
    }
    int m = (l + r) / 2, k = r - l + 1;
    vector<qr> left, right, cur;
    for (qr t: qs){
        if (t.r <= m){
            left.push_back(t);
            continue;
        }
        if (t.l > m){
            right.push_back(t);
            continue;
        }
        cur.push_back(t);
    }
    solve(l, m, left);
    solve(m + 1, r, right);
    vector<ll> p(k); 
    vector<int> g(k);
    p[m - l] = g[m - l] = a[m];
    for (int i = m - 1; i >= l; i--){
        p[i - l] = p[i - l + 1] + a[i];
        g[i - l] = gcd(g[i - l + 1], a[i]);
    }
    p[m - l + 1] = g[m - l + 1] = a[m + 1];
    for (int i = m + 2; i <= r; i++){
        p[i - l] = p[i - l - 1] + a[i];
        g[i - l] = gcd(g[i - l - 1], a[i]);
    }
    vector<pair<int, int>> fl, fr;
    int u = m + 1;
    while (u <= r){
        int v = u;
        while (u <= r && g[u] == g[v]){
            v++;
        }
        fr.push_back({u, v - 1});
        u = v;
    }
    u = m;
    while (u >= l){
        int v = u;
        while (v >= l && g[u] == g[v]){
            v--;
        }
        fl.push_back({v + 1, u});
        u = v;
    }
    sort(cur.begin(), cur.end(), cmp);
    u = 0;
    while (u < cur.size()){
        int v = u;
        while (v < cur.size() && cur[u].l == cur[v].l){
            v++;
        }
        ll pre = 0;
        for (int i = u; i < v; i++){
            int j = cur[i].i, d = 0;
            out[j] = 0;
            for (auto [l1, r1]: fl){
                if (r1 < cur[i].l) break;
                int lx = max(l1, cur[i].l);
                out[j] = max(out[j], p[lx - l] * g[lx - l]);
                while (d < fr.size() && fr[d].first <= cur[i].r){
                    int rx = min(fr[d].second, cur[i].r);
                    out[j] = max(out[j], (p[lx - l] + p[rx - l]) * gcd(g[lx - l], g[rx - l]));
                    out[j] = max(out[j], p[rx - l] * g[rx - l]);
                    d++;
                }
            }
            pre = max(pre, out[j]);
            out[j] = pre;
        }
        u = v;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q; cin>>n>>q;
    for(int i = 1; i <= n; i++){
        cin>>a[i];
    }
    vector<qr> qs;
    for (int i = 1; i <= q; i++){
        int l, r; cin>>l>>r;
        qs.push_back({l, r, i});
    }
    solve(1, n, qs);
    for (int i = 1; i<= q; i++){
        cout<<out[i]<<"\n";
    }
}
