#include <bits/stdc++.h>
using namespace std;
using ll = long long;

constexpr ll INF = 1000000000000000000LL;
constexpr ll sq = 317;

ll n, m, q, k, x, y, a, b, c;
vector<ll> v;
vector<ll> pr;
vector< vector<ll> > divs;

struct Mo {
    multiset<ll> ans;
    unordered_map< ll, deque< pair<ll, ll> > > mp;

    void push_back(ll x) {
        bool fl = 0;
        if (ans.size() == 0) {
            fl = 1;
        }
        // cout << '\t';
        // for (auto i : ans) {
        //     cout << i << ' ';
        // }
        // cout << endl;
        for (auto i : divs[x]) {
            if (fl || v[x - 1] % i != 0) {
                ans.insert(v[x] * i);
                mp[i].push_back({x, x});
            }
            else {
                ans.erase(ans.find(i * (pr[mp[i][mp[i].size() - 1].second + 1] - pr[mp[i][mp[i].size() - 1].first])));
                mp[i][mp[i].size() - 1].second++;
                ans.insert(i * (pr[mp[i][mp[i].size() - 1].second + 1] - pr[mp[i][mp[i].size() - 1].first]));
            }
        }
    }

    void pop_back(ll x) {
        for (auto i : divs[x]) {
            if (v[x - 1] % i != 0) {
                ans.erase(ans.find(v[x] * i));
                mp[i].pop_back();
            }
            else {
                ans.erase(ans.find(i * (pr[mp[i][mp[i].size() - 1].second + 1] - pr[mp[i][mp[i].size() - 1].first])));
                mp[i][mp[i].size() - 1].second--;
                ans.insert(i * (pr[mp[i][mp[i].size() - 1].second + 1] - pr[mp[i][mp[i].size() - 1].first]));
            }
        }
    }

    void pop_front(ll x) {
        for (auto i : divs[x]) {
            if (v[x + 1] % i != 0) {
                ans.erase(ans.find(v[x] * i));
                mp[i].pop_front();
            }
            else {
                ans.erase(ans.find(i * (pr[mp[i][0].second + 1] - pr[mp[i][0].first])));
                mp[i][0].first++;
                ans.insert(i * (pr[mp[i][0].second + 1] - pr[mp[i][0].first]));
            }
        }
    }

    ll get() {
        return *ans.rbegin();
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    cin >> n >> q;
    v.resize(n);
    divs.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        vector<ll> divs1;
        for (int j = 1; j * j <= v[i]; j++) {
            if (j * j == v[i]) {
                divs[i].push_back(j);
            }
            else if (v[i] % j == 0) {
                divs[i].push_back(j);
                divs1.push_back(v[i] / j);
            }
        }
        while (!divs1.empty()) {
            divs[i].push_back(divs1[divs1.size() - 1]);
            divs1.pop_back();
        }
    }
    pr.resize(n + 1);
    for (int i = 0; i < n; i++) {
        pr[i + 1] = pr[i] + v[i];
        // cout << pr[i + 1] << ' ';
    }
    // cout << '\n';
    vector< vector< pair< pair<ll, ll>, ll > > > vp(sq);
    for (int i = 0; i < q; i++) {
        cin >> x >> y;
        x--;
        y--;
        vp[y / sq].push_back({{x, y}, i});
    }
    vector<ll> ans(q);
    for (int i = 0; i < sq; i++) {
        if (vp[i].size() == 0) {
            continue;
        }
        // cout << i << endl;
        sort(vp[i].begin(), vp[i].end());
        // for (auto j : vp[i]) {
        //     cout << '\t' << j.first.first << ' ' << j.first.second << ' ' << j.second << endl;
        // }
        Mo m;
        for (int j = vp[i][0].first.first; j <= vp[i][0].first.second; j++) {
            // cout << '\t' << j << endl;
            m.push_back(j);
        }
        ans[vp[i][0].second] = m.get();
        // cout << ans[vp[i][0].second] << endl;
        ll l = vp[i][0].first.first;
        ll r = vp[i][0].first.second;
        for (int j = 1; j < vp[i].size(); j++) {
            // cout << vp[i][j].first.first << ' ' << vp[i][j].first.second << '\n';
            // cout << "I " << l << ' ' << r << endl;
            while (r < vp[i][j].first.second) {
                r++;
                m.push_back(r);
            }
            // cout << "II " << l << ' ' << r << endl;
            while (r > vp[i][j].first.second) {
                m.pop_back(r);
                r--;
            }
            // cout << "III " << l << ' ' << r << endl;
            while (l < vp[i][j].first.first) {
                m.pop_front(l);
                l++;
            }
            // cout << "IV " << l << ' ' << r << endl;
            ans[vp[i][j].second] = m.get();
            // cout << ans[vp[i][j].second] << endl;
        }
    }
    for (int j = 0; j < q; j++) {
        cout << ans[j] << '\n';
    }
}
