#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pldld;
const ll INF = 2e5+5, LONGBOI = 1e14+5;
mt19937 REALrandom(chrono::system_clock::to_time_t(chrono::system_clock::now()));

//struct mycomp{
//    bool operator()(str &a, str &b) const{
//    }
//};
//
//bool operator < (str &a, str &b){
//}

ll n, q, l, r;
ll t[4*INF];
ll a[INF];
ll f[INF];
ll p[INF];

void build(ll we, ll l, ll r){
    if(l == r) { t[we] = a[l]; /*cout << "we = " << we << " t = " << t[we] << endl;*/ return; }

    ll m = (l+r)>>1;
    build(2*we+1, l, m);
    build(2*we+2, m+1, r);

    t[we] = __gcd(t[2*we+1], t[2*we+2]);
    //cout << "we = " << we << " t = " << t[we] << endl;
    return;
}

ll getgcd(ll we, ll l, ll r, ll tl, ll tr){
    if(l > tr || r < tl) return 0;
    if(tl <= l && r <= tr) return t[we];

    ll m = (l+r)>>1;
    return (ll)__gcd(getgcd(2*we+1, l, m, tl, tr), getgcd(2*we+2, m+1, r, tl, tr));
}

ll getsum(ll l, ll r){
    if(l == 0) return p[r];
    return (p[r]-p[l-1]);
}

ll Get(ll pos, ll num){
    //cout << "pos = " << pos << " num = " << num << " getsum = " << getsum(pos, num) << " getgcd = " << getgcd(0, 1, n, pos, num) << endl;
    return getsum(pos, num) * getgcd(0, 1, n, pos, num);
}

ll Ternar(ll i){
    ll l = 0;
    ll r = i;
    //cout << "i = " << i << endl;

    ll m1, m2, k1, k2;
    while(l+1 < r){
        m1 = l + (r-l+1)/3;
        m2 = r - (r-l+1)/3;
        k1 = Get(m1, i);
        k2 = Get(m2, i);
        //cout << "l = " << l << " r = " << r << " m1 = " << m1 << " m2 = " << m2 << " k1 = " << k1 << " k2 = " << k2 << endl;
        if(k1 > k2){
            r = m2;
        }
        else{
            l = m1;
        }
    }
    if(l == 0) l++;

    //cout << "IN END l = " << l << " r = " << r << endl;
    //cout << "Getl = " << Get(l, i) << " GetR = " << Get(r, i) << endl;
    return max(Get(l, i), Get(r, i));
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> q;
    for(int i=1; i <= n; i++) cin >> a[i];
    for(int i=1; i <= n; i++) p[i] = p[i-1]+a[i];

    build(0, 1, n);

    f[1] = a[1]*a[1];
    for(int i=2; i <= n; i++){
        f[i] = max(f[i-1], max(Ternar(i), a[i]*a[i]));
        //cout << "i = " << i << " f = " << f[i] /*<< " Ternar(i) = " << Ternar(i)*/ << endl;
    }

    for(int I=1; I <= q; I++){
        cin >> l >> r;
        cout << f[r] << endl;
    }
    return 0;
}
